#include <iostream>

using namespace std;

int mod(int a, int m) {
	if(a < 0)
		return (m + a % m) % m;
	return a % m;
}

int add(int a, int b, int m) {
	return (a + b) % m;
}

int sub(int a, int b, int m) {
	return (m + a - b) % m;
}

int mul(int a, int b, int m) {
	return (a * b) % m;
}

int pow(int a, int b, int m) {
	int res = 1;
	while(b > 0) {
		if(b & 1 == 1)
			res = mul(res, a, m);
		a = mul(a, a, m);
		b >>= 1;
	}
	return res;
}

int main() {

	return 0;
}
