#include <iostream>

using namespace std;

int add(int a, int b, int m) {
	return (a + b) % m;
}

int sub(int a, int b, int m) {
	return (m + a - b) % m;
}

int mul(int a, int b, int m) {
	return (a * b) % m;
}

int pow(int a, int b, int m) {
	int res = 1;
	while(b > 0) {
		if(b & 1 == 1)
			res *= a;
		a *= a;
		b >>= 1;
	}
	return res;
}

int main() {
	int a = 10, c = 6, m = 19;
	int seed;
	cin >> seed;

	int x = seed;
	while(true) {
		x = add(mul(a, x, m), c, m);

		cin.ignore();
		cout << x;
	}
	return 0;
}
