#include <iostream>
#include <tuple>

using namespace std;

int euclid(int a, int b, int& x, int& y) {
	int r1 = a, r2 = b;
	int x1 = 1, x2 = 0;
	int y1 = 0, y2 = 1;

	while(r2 > 0) {
		int q = r1 / r2, r = r1 % r2;
		tie(r1, r2) = make_pair(r2, r1 - q * r2);
		tie(x1, x2) = make_pair(x2, x1 - q * x2);
		tie(y1, y2) = make_pair(y2, y1 - q * y2);
	}

	x = x1;
	y = y1;
	return r1;
}

int main() {
	int a, b, x, y, d;
	cin >> a >> b;

	d = euclid(a, b, x, y);

	cout << d << '=' << a << '*' << x << '+' << b << '*' << y << '\n';
	return 0;
}
